local HEARTBEAT_INTERVAL = 0.5; -- how many seconds per heartbeat of our internal timer
Simple_Coords_SecondsSinceUpdate=0; -- globalish tick counter

local mapIcon;
local worldTarget;
local panelOpen = false;
local target_visible = false;
local haveArrived=false;
local dest_x = -1000;
local dest_y = -1000;
local showWorldMapIcon = true;
local zone_dirty = true;

local HALF_PI = math.pi / 2;
-- Bring in AstroLabe
local DongleFrames = DongleStub("DongleFrames-1.0")
local Astrolabe = DongleStub("Astrolabe-1.0")-- DongleStub("Astrolabe-0.4")

function Simple_Coords_OnUpdate(self, elapsed)

	Simple_Coords_SecondsSinceUpdate = Simple_Coords_SecondsSinceUpdate + elapsed; 	
	if (Simple_Coords_SecondsSinceUpdate > HEARTBEAT_INTERVAL) then
	  if (zone_dirty) then
	    SetMapToCurrentZone();
	    zone_dirty = false;
	  end
		local x, y = GetPlayerMapPosition("player");
		
		-- if x and y and x > 0 and y > 0 then		 
		if x and y and x > 0 and y > 0 then
      Simple_CoordsText:SetText(format( "%.1f, %.1f", x * 100, y * 100));
      if (target_visible) then
        Astrolabe:UpdateMinimapIconPositions();
        mapIcon.dot:Show();
      end
		else
			Simple_CoordsText:SetText("---");
			mapIcon.dot:Hide();
		end
		Simple_Coords_SecondsSinceUpdate=0;
	end -- if
end

function SimpleCoords_OnLoad()
	-- create the dot: (encapsulated as an obbject in case we want to reuse it
	-- mapIcon=CreateFrame("Button", nil, Minimap)
	mapIcon=CreateFrame("Button", "SimpleCoordsDotFrame", Minimap)
	mapIcon:SetHeight(12)
	mapIcon:SetWidth(12)
	local texture = mapIcon:CreateTexture()
	texture:SetTexture("Interface\\AddOns\\SimpleCoords\\images\\redbull")
	texture:SetAllPoints()
	mapIcon.dot = texture
	--mapIcon.dot:Hide() -- start  hidden
	--mapIcon.dot:Show();
	mapIcon:SetScript("OnUpdate", SimpleCoords_MapIcon_Update)
		
	if (showWorldMapIcon) then
		worldTarget=CreateFrame("Button", "SimpleCoordsWorldTargetFrame",WorldMapDetailFrame )-- WorldMapDetailFrame
		worldTarget:SetWidth(16)
		worldTarget:SetHeight(16)
		
		-- looks like Widget specified in the astrolabe docs must contain an "icon"
		worldTarget.icon = worldTarget:CreateTexture("ARTWORK") 
		worldTarget.icon:SetAllPoints()
		worldTarget.icon:SetTexture("Interface\\AddOns\\SimpleCoords\\images\\redbull")
		worldTarget:RegisterEvent("WORLD_MAP_UPDATE")
		worldTarget:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		worldTarget:SetScript("OnEvent", SimpleCoords_worldIcon_OnEvent)
		worldTarget.x=-1000
		worldTarget.y=-1000
		worldTarget.inUse=false
	end
	-- create the arrow:
	local model = CreateFrame("Model", nil, icon)
	model:SetHeight(140.8)
	model:SetWidth(140.8)
	model:SetPoint("CENTER", Minimap, "CENTER", 0, 0)
	model:SetModel("Interface\\Minimap\\Rotating-MinimapArrow.mdx")
	model:SetModelScale(.600000023841879)

	model.parent = mapIcon
	mapIcon.arrow = model
	model:SetScript("OnUpdate", SimpleCoords_MapIcon_UpdateArrow)
	model:Hide()
	-- mapIcon.arrow:Show();
	-- add a "showing" flag:
	mapIcon.inUse=false;
	
	-- Register the slash command
	SLASH_SIMPLECOORDS1 = "/dest";
	SlashCmdList["SIMPLECOORDS"] = SimpleCoords_CommandLine;
	-- make a global for testing:
	--SimpleCoordsMapIcon=mapIcon;
	
	-- DEFAULT_CHAT_FRAME:AddMessage("SimpleCoords loaded. Shift-drag to move the window. Click window to toggle panel. ENTER to set new value.",  0.5, 1.0, 0.5, 1);

end



function SimpleCoords_AcceptValue()
	-- DEFAULT_CHAT_FRAME:AddMessage("ENTER has been pressed",  0.5, 1.0, 0.5, 1);
	-- check to see if we need to remove an existing one:
	if (mapIcon.inUse) then
	-- clear existing icon:
		Astrolabe:RemoveIconFromMinimap( mapIcon );
		mapIcon.inUse=false;
	end
	if (getglobal("SimpleCoords_X"):GetText() == "" and getglobal("SimpleCoords_Y"):GetText() == "") then
		SimpleCoords_TogglePanel();
	else
		getglobal("SimpleCoords_X"):ClearFocus();
		getglobal("SimpleCoords_Y"):ClearFocus();
		if (getglobal("SimpleCoords_X"):GetText() == "" or getglobal("SimpleCoords_Y"):GetText() == "") then
		-- only one field filled in
		else
			PlaySoundFile("Sound\\interface\\PickUp\\PutDownGems.wav");
			local x_text, y_text;
			x_text = getglobal("SimpleCoords_X"):GetText();
			y_text = getglobal("SimpleCoords_Y"):GetText();
			y_text = gsub(y_text, ",", ".");
			y_text = gsub(y_text, "[%a%c%-%(%)]", ""); -- %a: letters. %c: control characters %-: - 
			x_text = gsub(x_text, ",", ".");
			x_text = gsub(x_text, "[%a%c%-%(%)]", ""); -- %a: letters. %c: control characters %-: - 
			dest_x=tonumber(x_text)/100.0;
			dest_y=tonumber(y_text)/100.0;
			if (showWorldMapIcon) then
				worldTarget.x=dest_x
				worldTarget.y=dest_y
				worldTarget.inUse=true
			end
			local ppContinent, ppZone, ppX, ppY=Astrolabe:GetCurrentPlayerPosition();
			local r=Astrolabe:PlaceIconOnMinimap( mapIcon, ppContinent, ppZone, dest_x, dest_y );
				-- DEFAULT_CHAT_FRAME:AddMessage('result='..r..', '..ppContinent..', '..ppZone..', '..dest_x..', '..dest_y,  0.5, 1.0, 0.5, 1);
			mapIcon.inUse=true;
			target_visible=true;
			Astrolabe:UpdateMinimapIconPositions();
			haveArrived=false;
		end
		
	end
end

function SimpleCoords_TogglePanel()
	if(getglobal("SimpleCoords_X"):IsShown()) then
		PlaySoundFile("Sound\\interface\\uMiniMapClose.wav");

		getglobal("SimpleCoords_X"):Hide();
		getglobal("SimpleCoords_Y"):Hide();
		getglobal("SimpleCoords_X"):ClearFocus();
		getglobal("SimpleCoords_Y"):ClearFocus();
		Astrolabe:RemoveIconFromMinimap(mapIcon);
		--if (getglobal("worldTarget") ~= nil) then
		--	getglobal("worldTarget"):Hide();
		--end
		if (worldTarget ~= nil) then
			worldTarget:Hide();
		end
		Astrolabe:UpdateMinimapIconPositions();
		mapIcon.inUse=false;
		panelOpen=false;
		dest_x=-1000;
		dest_y=-1000;
		target_visible = false;
	else
		PlaySoundFile("Sound\\interface\\uMiniMapOpen.wav");
		getglobal("SimpleCoords_X"):Show();
		getglobal("SimpleCoords_Y"):Show();
		getglobal("SimpleCoords_X"):SetFocus();
		panelOpen=true;
	end


end

function SimpleCoords_MapIcon_UpdateArrow(self, elapsed)
	local angle = Astrolabe:GetDirectionToIcon(mapIcon)
	if (angle ~= nil) then
		local x = .03875* math.cos(angle + HALF_PI) + 0.04875 
		local y = .03875* math.sin(angle + HALF_PI) + 0.04875 
		self:SetPosition(x,y,0)
		self:SetFacing(angle)
	else
		self:Hide()
	end
end

function SimpleCoords_MapIcon_Update(self, elapsed)
	local edge = Astrolabe:IsIconOnEdge(self)
	local dot = self.dot:IsShown()
	local arrow = self.arrow:IsShown()

	if (edge and not arrow) then

		self.arrow:Show()
		self.dot:Hide()
	elseif not edge and not dot then
		self.dot:Show()
		self.arrow:Hide()
	end

	local dist,x,y = Astrolabe:GetDistanceToIcon(self)
	if (dist and dist < 10) then
		if (not haveArrived) then	
			-- let them now they have arrived
			DEFAULT_CHAT_FRAME:AddMessage("You have arrived.",  0.8, 1.0, 0.5, 1);
			haveArrived=true;
			-- if (getglobal("worldTarget") ~= nil) then
			if (showWorldMapIcon) then
			--
				worldTarget:IsShown(false); -- no idea why this doesn't work...
				worldTarget.x=-1000
				worldTarget.y=-1000
				worldTarget.inUse=false
				-- worldTarget:Hide(); -- should always exist
			end
			self:Hide()

			-- self.arrow:Hide()
		end
	else
		haveArrived=false;

	end
	
end



function SimpleCoords_worldIcon_OnEvent(self, event, ...)
	if (showWorldMapIcon) then
		if (event == "WORLD_MAP_UPDATE") then
				if not self then
					return
				end
				
				if self.inUse then -- worldTarget
				
					if (dest_x>0 and dest_y>0) then
						local continent, zone, x, y=Astrolabe:GetCurrentPlayerPosition();
				--		DEFAULT_CHAT_FRAME:AddMessage("continent:"..continent .. ", zone:"..zone,  0.8, 1.0, 0.5, 1);
					haveArrived=true;
						-- local world_result=PlaceIconOnWorldMap( worldMapFrame, icon, continent, zone, xPos, yPos ) - places an icon on the specified world map frame 
						local world_result=Astrolabe:PlaceIconOnWorldMap( WorldMapDetailFrame, worldTarget, continent, zone, dest_x, dest_y )
						
						if (x and y and (0 < x and x <= 1) and (0 < y and y <= 1)) then
							self:Show()
						else
							self:Hide()
						end
						
					else
						self:Hide()
					end
				else
					self:Hide()
				end
	
		end
	end
end
if (event == "ZONE_CHANGED_NEW_AREA") then
  zone_dirty = true;
end


-- Tooltips:
--------------

function SimpleCoords_ShowTooltip()
	local tooltipList ={};
	GameTooltip:SetOwner(getglobal("SimpleCoordsFrame") , "ANCHOR_CURSOR", -5, 5);
	-- GameTooltip:SetOwner(owner, "anchor"[, +x, +y]);
	--GameTooltip:AddLine("test", .6,1.0,.8); -- GameTooltip:AddLine(name, GameTooltip_UnitColor("player"));\
	GameTooltip:AddLine('SimpleCoords',.6,1.0,.8);
	GameTooltip:AddLine('Click to enter coordinates.');
	GameTooltip:AddLine('Shift-click to move.');
	GameTooltip:AddLine('ENTER to place dot at coordinates.');
	GameTooltip:Show();
end

function SimpleCoords_HideTooltip()
	GameTooltip:Hide();
end
  
function SimpleCoordsEnter_ShowTooltip()
	local tooltipList ={};
	GameTooltip:SetOwner(getglobal("SimpleCoordsFrame") , "ANCHOR_CURSOR", -5, 5);
	-- GameTooltip:SetOwner(owner, "anchor"[, +x, +y]);
	--GameTooltip:AddLine("test", .6,1.0,.8); -- GameTooltip:AddLine(name, GameTooltip_UnitColor("player"));\
	GameTooltip:AddLine('SimpleCoords',.6,1.0,.8);
	GameTooltip:AddLine('TAB to switch fields.');
	GameTooltip:AddLine('Click current coordinates to close edit.');
	GameTooltip:AddLine('ENTER to place dot at coordinates.');
	GameTooltip:Show();
end


-- command line parameters: (slash command handler)
----------------------------------------------------
function SimpleCoords_CommandLine(msg)
	cmd=string.lower(msg)
	
	
end
